//+------------------------------------------------------------------+
//|                                                  MultiCharts.mq4 |
//|                                      Copyright  2009, KTS Group |
//|                                                      www.koss.su |
//|                                                developed by Koss |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, KTS Group"
#property link      "www.koss.su"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_minimum -15
#property indicator_maximum 115


extern color  BearCandleColor    = Crimson;
extern color  BullCandleColor    = Black;
extern color  TextColor          = Gray;
extern color  ProfitColor        = Green;
extern color  LossColor          = Red;
extern color  TakeProfitColor    = LimeGreen;
extern color  StopLossColor      = IndianRed;
extern color  FastMA_Color       = Green;
extern color  SlowMA_Color       = OrangeRed;
extern int    FastMA_Period      = 21;
extern int    SlowMA_Period      = 34;
extern int    MA_Metod           = 0;
extern int    Applied_Price      = 0;
extern bool   UseMovingAverages  =true;
extern bool   UseHeikenAshiChart =false;
extern bool   ViewOHLC           =true;
extern bool   UseSorting         =true;                           
extern bool   MonitoringPositions=true;
extern int    ProfitCalcMode     =0;                                
extern int    PercentCalcMode    =1;                               
extern int    Charts             =6;
extern string Chart1             ="EURUSD";
extern string Chart2             ="GBPUSD";
extern string Chart3             ="AUDUSD";
extern string Chart4             ="USDCAD";
extern string Chart5             ="USDCHF";
extern string Chart6             ="USDJPY";

//+------------------------------------------------------------------+
//|defines                                                           |
//+------------------------------------------------------------------+

#define TotalCharts                                        6

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double SlowMABuffer[];
double FastMABuffer[];


//----
int    CandelsCountOnWindow=0,
       Frame,
       hWnd,
       Win_Charts,
       CandleWidth,
       HistoWidth,
       MAWidth=1,
       TimeFrame,
       MA,
       Ap_Price,
       idWnd;       

       
color  Win_color;
color  clNames[TotalCharts];                            // Color matrix
double ChartValues[7][4];                               // Values matrix min,max,(max-min)/100;
double TotalOrders[7][31][8];                           // Orders matrix
double Vol[7][3];                                       // 
   
   int TotalBars[TotalCharts];                          // 
datetime FrameThresolds[7][3];                          // 
double HAClose[];
static datetime icTime[TotalCharts],
                DayBarTime[TotalCharts],
                ZeroBarTime[TotalCharts];
int    Hystory[TotalCharts];
string Win_Name,
       ChartNames[TotalCharts];
bool   StartTerminal=true;
double open,close,high,low,min,max,point,price,haopen, hahigh, halow, haclose,FastMA,SlowMA;

//+------------------------------------------------------------------+
//|include DLL functions                                             |
//+------------------------------------------------------------------+
#import "user32.dll"
   int    GetWindowDC(int dc);
   int    ReleaseDC(int h, int dc);
   bool   GetWindowRect(int h, int& pos[4]);
#import

#import "gdi32.dll"
   int    GetPixel(int dc, int x, int y);
#import
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   Win_Name = "KTS";
   IndicatorShortName(Win_Name);
   idWnd=WindowFind(Win_Name);
   DeleteAllObjects(OBJ_TEXT); 
   DeleteAllObjects(OBJ_LABEL); 
   DeleteAllObjects(OBJ_TREND);
         
          
         if (Charts<1 || Charts>6)                Win_Charts=6;
           else Win_Charts  = Charts; 
          
         if (MA_Metod<0 || MA_Metod>3)            MA=0;
           else MA=MA_Metod;
           
         if (Applied_Price<0 || Applied_Price>6)  Ap_Price=0;
           else Ap_Price=Applied_Price;
           
     if (WindowBarsPerChart()!=0 && IsDllsAllowed())
        {
         Win_color   = GetWndColor(Symbol()); 
         CandleWidth = GetCandleWidth(Symbol());
         ChartsInit();
         CandelsCountOnWindow=WindowFirstVisibleBar();
         Frame = MathRound((CandelsCountOnWindow)/Win_Charts);
         switch(CandleWidth)
            {
             case 1:  HistoWidth=0;
                      MAWidth=1;    break;
             case 2:  HistoWidth=0;
                      MAWidth=1;    break;
             case 4:  HistoWidth=2;
                      MAWidth=1;    break;
             case 8:  HistoWidth=3; 
                      MAWidth=2;    break;
             case 16: HistoWidth=7; 
                      MAWidth=2;    break;
             case 32: HistoWidth=13;
                      MAWidth=3;    break;
            }
        IndicatorSets(false); 
           
        } 
        
    return(0);
  }
  
   
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int err;
   if(IsConnected() && WindowBarsPerChart()!=0 && Bars!=0 && AccountNumber()!=0 && IndicatorCounted()!=0 && IsDllsAllowed()) 
      {
      if (CheckHystory())
        {
         if(UseSorting && (isNewDayBar() || StartTerminal))
          {
           DeleteAllObjects(OBJ_TREND);
           Sorting();
           StartTerminal=false;
          }
        }
     
       if (!WndRepaint())
        {
          Symbolic(); 
        }
          
      }  
      else
       {
        StartTerminal=true;
        CleanHisto();
        init();
       } 
       return(-1);     
      
  }  
  
int deinit()
   {
    
   }
    
void ChartsInit()
   {
    LoadChartsNames();
    InitArrays();
   } 
 
void LoadChartsNames()
   {
    ChartNames[0]=Chart1;
    ChartNames[1]=Chart2;
    ChartNames[2]=Chart3;
    ChartNames[3]=Chart4;
    ChartNames[4]=Chart5;
    ChartNames[5]=Chart6;
   }
bool CheckHystory()
   {
    bool Result=true;
    
    for(int i=0; i<=Win_Charts-1;i++)
     {
      if (Hystory[i]==1) continue;
       else
         Result=false;
         break;
     }
     return(Result);
   } 
    
void InitArrays()
   {
    ArrayInitialize(Hystory,0);
    ArrayInitialize(TotalBars,0);
    ArrayInitialize(TotalOrders,0);
    ArrayInitialize(FrameThresolds,0);
    if (UseSorting)ArrayInitialize(Vol,0);
    if (UseHeikenAshiChart && UseMovingAverages)
     {
      ArrayResize(HAClose,CandelsCountOnWindow*3);
      ArraySetAsSeries(HAClose,true);
     } 
     for(int i=0;i<=Win_Charts-1;i++)
      {
       ZeroBarTime[i]=0;
       DayBarTime[i]=0;
       icTime[i]=0;
       clNames[i]=BullCandleColor;
       continue;
      }
   }    
   
void LoadChartsValues()
   {
    DeleteAllObjects(OBJ_TREND);
    for(int i=0;i<=Win_Charts-1;i++) 
     {
      CellThresolds(i);
      UpgradeCharts(i);
      continue;
     }
   }

void UpgradeCharts(int ChartListPosition)
   { 
     int j;
     double min=0,max=0,haop=0,hacl=0;
     string Symb=ChartNames[ChartListPosition];
     if (Hystory[ChartListPosition]==1)
      {
      if (!UseHeikenAshiChart)
       {
        max=iHigh(Symb,0,iHighest(Symb,0,MODE_HIGH,Frame-3,0));
        min=iLow(Symb,0,iLowest(Symb,0,MODE_LOW,Frame-3,0));
       }
       else
       {
        haop=iCustom(Symb,0,"Heiken Ashi",2,0);
        hacl=iCustom(Symb,0,"Heiken Ashi",3,0);
        if (haop>hacl)
         {
          max=iCustom(Symb,0,"Heiken Ashi",0,0);
          min=iCustom(Symb,0,"Heiken Ashi",1,0);
         }
         else
         {
          max=iCustom(Symb,0,"Heiken Ashi",1,0);
          min=iCustom(Symb,0,"Heiken Ashi",0,0);
         } 
         
        for (j=0;j<=Frame-4;j++)
         {
          haop=iCustom(Symb,0,"Heiken Ashi",2,j);
          hacl=iCustom(Symb,0,"Heiken Ashi",3,j);
          
          if (haop>hacl)
           {
            if (iCustom(Symb,0,"Heiken Ashi",0,j)>max)  max=iCustom(Symb,0,"Heiken Ashi",0,j);
            if (iCustom(Symb,0,"Heiken Ashi",1,j)<min)  min=iCustom(Symb,0,"Heiken Ashi",1,j);
           }
           else 
           {
            if (iCustom(Symb,0,"Heiken Ashi",1,j)>max)  max=iCustom(Symb,0,"Heiken Ashi",1,j);
            if (iCustom(Symb,0,"Heiken Ashi",0,j)<min)  min=iCustom(Symb,0,"Heiken Ashi",0,j);
           }
         }
       } 
       ChartValues[ChartListPosition+1,1]=((max-min)/100);
       ChartValues[ChartListPosition+1,2]= max;
       ChartValues[ChartListPosition+1,3]= min;
       CleanFrame(ChartListPosition+1);
       DrawChart(ChartListPosition);
       MonitoringOpenPositions(ChartListPosition);
       
      } 
      else
      {
       ChartValues[ChartListPosition+1,1]=0;
       ChartValues[ChartListPosition+1,2]=0;
       ChartValues[ChartListPosition+1,3]=0;
       CleanFrame(ChartListPosition+1);
       ChartName(ChartListPosition,clNames[ChartListPosition]," ");
      }
       DrawSeparateLines(ChartListPosition);
       ChartValues[0,0]=ChartListPosition+1;
       CellThresolds(ChartListPosition);
      
   }
      
//+------------------------------------------------------------------+
//|Refresh Data                                                 |
//+------------------------------------------------------------------+
   
int RefreshRate(int ChartListPosition)
   {
     string   Symb;
     Symb=ChartNames[ChartListPosition];
     return(CopyRates(Symb,ChartListPosition));
   }
   
//This function probably to optimise using iBarShift(),
  
int CopyRates(string Symb, int ChartListPosition )
   {
    datetime times[];
    int error,CountedBars=0,pos=ChartListPosition+1;
    CountedBars=ArrayCopySeries(times,MODE_TIME,Symb,0);
    error=GetLastError();
    if(error==4066)
     {
      Print(Symb+",The requested data in the course of updating!","(",error,")");
      return(0);
     }
     if(error==4053)
     {
      Print("Check up "+Symb +" presence in the market review!","(",error,")");
      return(0);
     }
    if((iTime(Symb,0,0)==times[0] && iTime(Symb,0,0)==Time[0])&& 
       (iTime(Symb,0,1)==times[1] && iTime(Symb,0,1)==Time[1])&& 
       (iTime(Symb,0,2)==times[2] && iTime(Symb,0,2)==Time[2]) )
       {
       if (!UseHeikenAshiChart)
         {
           ZeroBarTime[ChartListPosition]=iTime(Symb,0,0);
           TotalBars[ChartListPosition]=iBars(Symb,0); 
         }
          if(UseSorting && Win_Charts>1)
            {
              Vol[ChartListPosition+1][1]=ChartListPosition;
              Vol[ChartListPosition+1][2]=GetVol(ChartListPosition);
            }
           return(1);
       }
       else
       {
        Print(Symb+",Absence of historical data");
        return(0); 
       }
  
   }
    
//+------------------------------------------------------------------+
//|Drawing ChartNames and other labels                               |
//+------------------------------------------------------------------+

void ChartName(int ChartListPosition,color clPosition,string txPosition)
   {
   
    int k=MathRound(Frame/2);
   
      if (ChartListPosition==0)
       {
        DrawChartsName(ChartListPosition,k,clPosition,txPosition);
       }
        else
       {
        DrawChartsName(ChartListPosition,k+ChartListPosition*Frame,clPosition,txPosition);
       }
    }
    
void DrawChartsName(int ChartListPosition,int Bar,color clPosition,string txPosition)
   {
    
    string name,Symb=ChartNames[ChartListPosition];                     
    
   
    
    name="Chart"+Symb; 
   
    if (!UseHeikenAshiChart)
         {
          CleanText(name);
          CleanText("Update "+name);
          CreateTextObject(Win_Name,name, Time[Bar],113,Symb+TF()+txPosition,clPosition,"tahoma",7); 
          if (Hystory[ChartListPosition]==0 )
           {
            CreateTextObject(Win_Name,"Update "+name, Time[Bar],55,"WAITING FOR UPDATE...",BullCandleColor,"tahoma",7); 
           }
           else
           {
            InfoPosition(ChartListPosition);  
            CleanText("Update "+name);
           }
         }
         else
         {
          CleanText(name);
          CleanText("Update "+name);
          CreateTextObject(Win_Name,name, Time[Bar],113,Symb+TF()+" (HA)"+txPosition,clPosition,"tahoma",7); 
           if (Hystory[ChartListPosition]==0 )
           {
            CreateTextObject(Win_Name,"Update "+name, Time[Bar],55,"WAITING FOR UPDATE...",BullCandleColor,"tahoma",7); 
           } 
            else
           {
            InfoPosition(ChartListPosition);  
            CleanText("Update "+name);
           }
         } 
        
   }   


void OHLC(int ChartListPosition)
   {

    int k=MathRound(Frame/2),p=Frame-(Frame-5);
   
      if (ChartListPosition==0)
       {
        DrawOHLC(ChartListPosition,k);
        DrawMaxMinValues(ChartListPosition,p);
       }
        else
       {
        DrawOHLC(ChartListPosition,k+ChartListPosition*Frame);
        DrawMaxMinValues(ChartListPosition,p+ChartListPosition*Frame);
       }
      
   }
   
void DrawOHLC(int ChartListPosition,int Bar)
   { 
    double dig,high,open,low,close,Zlow,Zhigh;
       string Symb=ChartNames[ChartListPosition],ohlc,name,codes,cc;
       name="OHLC "+Symb;
       dig=MarketInfo(Symb,MODE_DIGITS);
    
       if (!UseHeikenAshiChart)
         {
          high=NormalizeDouble(Hi(Symb,0,0),dig);
          open=NormalizeDouble(Op(Symb,0,0),dig);
          close=NormalizeDouble(Cl(Symb,0,0),dig);
          low=NormalizeDouble(Lo(Symb,0,0),dig);
             if (ViewOHLC) ohlc=DoubleToStr(open,dig)+"  "+DoubleToStr(high,dig)+"  "+DoubleToStr(low,dig)+"  "+DoubleToStr(close,dig);
          CleanText(name);
          CreateTextObject(Win_Name,name, Time[Bar],-7,ohlc,clNames[ChartListPosition],"tahoma",8); 
         }
         else
         {
          high=NormalizeDouble(Hi(Symb,0,0),dig);
          low=NormalizeDouble(Lo(Symb,0,0),dig);
          open=iCustom(Symb,0,"Heiken Ashi",2,0);
          close=iCustom(Symb,0,"Heiken Ashi",3,0);
          Zhigh=MathMax(high, MathMax(open, close));
          Zlow=MathMin(low, MathMin(open, close));
             if (ViewOHLC) ohlc=DoubleToStr(open,dig)+"  "+DoubleToStr(Zhigh,dig)+"  "+DoubleToStr(Zlow,dig)+"  "+DoubleToStr(close,dig);
          CleanText(name);
          CreateTextObject(Win_Name,name, Time[Bar],-7,ohlc,clNames[ChartListPosition],"tahoma",8); 
         }  
   } 
   

void InfoPosition(int ChartListPosition)
   {
     int pos=Frame-3;
      if (ChartListPosition==0)
       {
         DrawInfoPosition(ChartListPosition,pos);   
       }
        else
       {
         DrawInfoPosition(ChartListPosition,pos+ChartListPosition*Frame); 
       }
   }
     
void DrawInfoPosition(int ChartListPosition,int Bar)     
   {
    string name,text,Symb=ChartNames[ChartListPosition];
     name=" Spread "+Symb;
     double percent=GetPercent(Symb,PercentCalcMode);
        int dig=MarketInfo(Symb,MODE_DIGITS);
        int pips=MathPow(10,dig);
    
       text=DoubleToStr(MarketInfo(Symb,MODE_SPREAD)*MarketInfo(Symb,MODE_POINT)*pips,1);
     
     CleanText(name);
     CreateTextObject(Win_Name,name, Time[Bar],106,text,TextColor,"tahoma",7);
     if (PercentCalcMode==0 )
      {
       name=" Percent "+Symb;
       CleanText(name);
       text=DoubleToStr(percent,2)+"%"; 
       if (percent>0)
        {     
         CreateTextObject(Win_Name,name, Time[Bar-2],-1,text,ProfitColor,"tahoma",7);
        } 
        else
        {
         if (percent<0)
          {
           CreateTextObject(Win_Name,name, Time[Bar-2],-1,text,LossColor,"tahoma",7);
          }
         if (percent==0) 
          {
           CreateTextObject(Win_Name,name, Time[Bar-2],-1,text,TextColor,"tahoma",7);
          }
        }
      }
      else
      {
       name=" Percent "+Symb;
        CleanText(name);
        text=DoubleToStr(percent,0); 
        if (percent>0)
         {     
          CreateTextObject(Win_Name,name, Time[Bar-1],-1,text,ProfitColor,"tahoma",7);
         } 
         else
         {
          if (percent<0)
           {
            CreateTextObject(Win_Name,name, Time[Bar-1],-1,text,LossColor,"tahoma",7);
           }
          if (percent==0) 
           {
            CreateTextObject(Win_Name,name, Time[Bar-1],-1,text,TextColor,"tahoma",7);
           }
         }
       
               
      }
   
 }
      
void DrawMaxMinValues(int ChartListPosition,int Bar)
   {
    string name,name1,Value,Symb=ChartNames[ChartListPosition];
     name="Max "+Symb;
     name1="Min "+Symb;
     
     Value=DoubleToStr(ChartValues[ChartListPosition+1,2],MarketInfo(Symb,MODE_DIGITS));
     CleanText(name);
     CreateTextObject(Win_Name,name, Time[Bar],106,Value,TextColor,"tahoma",7);
     
     Value=DoubleToStr(ChartValues[ChartListPosition+1,3],MarketInfo(Symb,MODE_DIGITS));
     CleanText(name1); 
     CreateTextObject(Win_Name,name1, Time[Bar],-1,Value,TextColor,"tahoma",7);
   } 

void CleanText(string objName)
   {
    ObjectDelete(objName);
   }
 
//+------------------------------------------------------------------+
//|Clear ChartCeil                                                   |
//+------------------------------------------------------------------+
   
void CleanFrame(int ChartListPosition)
   {
    int i;
    if (ChartListPosition==1)
     {
       if (ChartListPosition!=Win_Charts)
        {
         for(i=0;i<=Frame;i++)
           {
            CleanBuffers(i);
           }
         }  
        else
        {
         for(i=0;i<=Bars;i++)
           {
            CleanBuffers(i);
           }
        } 
       
     }
     else
     {
      if (ChartListPosition!=Win_Charts)
        {
         for(i=ChartListPosition*Frame;i>=(ChartListPosition-1)*Frame;i--)
         {
          CleanBuffers(i);
         } 
        }
        else
        {
         for(i=(ChartListPosition-1)*Frame;i<=Bars;i++)
         {
          CleanBuffers(i);
         } 
        } 
     }
    
   }  
   
//+------------------------------------------------------------------+
//|Function of tracking changes of a window of the current schedule  |
//+------------------------------------------------------------------+
      
bool WndRepaint()
   {
     if ( Win_color   != GetWndColor(Symbol())    || 
          CandleWidth != GetCandleWidth(Symbol()) || 
          CandelsCountOnWindow!=WindowFirstVisibleBar() )
       { 
         CleanHisto();
         CandelsCountOnWindow=WindowFirstVisibleBar();
         Frame = MathRound((CandelsCountOnWindow)/Win_Charts); 
         Win_color   = GetWndColor(Symbol());
         CandleWidth=GetCandleWidth(Symbol());
         switch(CandleWidth)
            {
             case 1:  HistoWidth=0;
                      MAWidth=1;    break;
             case 2:  HistoWidth=0;
                      MAWidth=1;    break;
             case 4:  HistoWidth=2;
                      MAWidth=1;    break;
             case 8:  HistoWidth=3; 
                      MAWidth=2;    break;
             case 16: HistoWidth=7; 
                      MAWidth=2;    break;
             case 32: HistoWidth=13;
                      MAWidth=3;    break;
            }
    
         IndicatorSets(true);
         return(true);
        }
        
      return(false);  
   }    
   
//+------------------------------------------------------------------+
//|Custom indicator settings                                         |
//+------------------------------------------------------------------+
   
void IndicatorSets(bool Repaint)
   {
        
         /*ArrayInitialize(ChartValues,0.0); */       
         SetIndexStyle(0,DRAW_HISTOGRAM, 0, HistoWidth, BearCandleColor);
         SetIndexBuffer(0, ExtMapBuffer1);
         SetIndexDrawBegin(0,Bars-CandelsCountOnWindow-4);
         SetIndexLabel(0,"");
          
         SetIndexStyle(1,DRAW_HISTOGRAM, 0, HistoWidth, BullCandleColor);
         SetIndexBuffer(1, ExtMapBuffer2);
         SetIndexDrawBegin(1,Bars-CandelsCountOnWindow-4);
         SetIndexLabel(1,"");
         
         SetIndexStyle(2,DRAW_HISTOGRAM, 0, HistoWidth, Win_color);
         SetIndexBuffer(2, ExtMapBuffer3);
         SetIndexDrawBegin(2,Bars-CandelsCountOnWindow-4);
         SetIndexLabel(2,"");
         
         SetIndexStyle(3,DRAW_HISTOGRAM, 0, 1, BearCandleColor);
         SetIndexBuffer(3, ExtMapBuffer4);
         SetIndexDrawBegin(3,Bars-CandelsCountOnWindow-4);
         SetIndexLabel(3,"");
         
         SetIndexStyle(4,DRAW_HISTOGRAM, 0, 1, BullCandleColor);
         SetIndexBuffer(4, ExtMapBuffer5);
         SetIndexDrawBegin(4,Bars-CandelsCountOnWindow-4);
         SetIndexLabel(4,"");
         
         SetIndexStyle(5,DRAW_HISTOGRAM, 0, 1, Win_color);
         SetIndexBuffer(5, ExtMapBuffer6);
         SetIndexDrawBegin(5,Bars-CandelsCountOnWindow-4);
         SetIndexLabel(5,"");
         
         SetIndexStyle(6,DRAW_LINE, 0, MAWidth, SlowMA_Color);
         SetIndexBuffer(6, SlowMABuffer);
         SetIndexDrawBegin(6,Bars-CandelsCountOnWindow-4);
         SetIndexLabel(6,"");
          
         SetIndexStyle(7,DRAW_LINE,0,MAWidth,FastMA_Color);
         SetIndexBuffer(7, FastMABuffer);
         SetIndexDrawBegin(7,Bars-CandelsCountOnWindow-4);
         SetIndexLabel(7,"");
         
        if (Repaint)
         {
          LoadChartsValues();
         }
   }
 
//+------------------------------------------------------------------+
//|Return width bar                                                  |
//+------------------------------------------------------------------+
          
int GetCandleWidth(string sy)
{
 
  int rect[4];
  int h=WindowHandle(sy, Period());
  if(h==0) return(-1);
  GetWindowRect(h, rect);
  int wW  = rect[2] - rect[0]; //  
  int bpc = WindowBarsPerChart();
  if(bpc==0) return(-1);
  return(MathFloor((wW-48)/bpc));
}  

//+------------------------------------------------------------------+
//|Return background color                                           |
//+------------------------------------------------------------------+
  
int GetWndColor(string sy)
   { 
     int hWnd = WindowHandle(sy, Period());
     int hDC = GetWindowDC(hWnd);
     int rect[4];
     GetWindowRect(hWnd, rect);
     int wW = rect[2] - rect[0];         // width window
     int wH = rect[3] - rect[1];         // heigth window
     
     int col = GetPixel(hDC, 2, 2);
     if(col==-1)                         // 
     {
       col = GetPixel(hDC, wW-3, wH-3); 
       if(col==-1)                       // 
       col = GetPixel(hDC, 2, wH-3); 
       if(col==-1)                       // 
       col = GetPixel(hDC, wW-3, 2);     
       if(col==-1)                       //
       {
         ReleaseDC(hWnd, hDC);
         return(Win_color);
       }
      }
     ReleaseDC(hWnd, hDC);
     return(col);
   }
    
//+------------------------------------------------------------------+
//|Clear indicator buffers                                           |
//+------------------------------------------------------------------+
   
void CleanBuffers(int i)
   {
    
      ExtMapBuffer1[i]=EMPTY_VALUE;
      ExtMapBuffer2[i]=EMPTY_VALUE;
      ExtMapBuffer3[i]=EMPTY_VALUE;
      ExtMapBuffer4[i]=EMPTY_VALUE;
      ExtMapBuffer5[i]=EMPTY_VALUE;
      ExtMapBuffer6[i]=EMPTY_VALUE;
      SlowMABuffer[i]=EMPTY_VALUE;
      FastMABuffer[i]=EMPTY_VALUE;
   
   }
   
//+------------------------------------------------------------------+
//|Draw chart (all bars)                                             |
//+------------------------------------------------------------------+

void DrawChart(int ChartListPosition)
   {
     string Symb=ChartNames[ChartListPosition];
     int j,k=Frame-4;
  
      if (UseHeikenAshiChart && UseMovingAverages)
        {
         
        for(j=0;j<=CandelsCountOnWindow*3;j++)
         { 
          HAClose[j]=iCustom(Symb,0,"Heiken Ashi",3,j);
         }
     
        } 
      
        for(j=k;j>=0;j--)
         { 
          SetValues(j,ChartListPosition);
         }
   }
   
//+------------------------------------------------------------------+
//|Draw chart(zero bar)                                              |
//+------------------------------------------------------------------+ 

void DrawZeroBar(int ChartListPosition)   
   {
    double Zmin,Zmax,LastPrice; 
    string Symb=ChartNames[ChartListPosition];
       LastPrice=MarketInfo(Symb,MODE_BID);
       Zmin=ChartValues[ChartListPosition+1][3];
       Zmax=ChartValues[ChartListPosition+1][2];
       if (LastPrice<Zmin || LastPrice>Zmax)
        {
         UpgradeCharts(ChartListPosition);
        }
    SetValues(0,ChartListPosition);  
   }
   
void SetValues(int Bar,int ChartListPosition)
   {

    string Symb=ChartNames[ChartListPosition];

    min=ChartValues[ChartListPosition+1][3];
    point=ChartValues[ChartListPosition+1][1];
    if (!UseHeikenAshiChart)
        { 
         open = (Op(Symb,0,Bar)-min)/point;
         close= (Cl(Symb,0,Bar)-min)/point;
         high = (Hi(Symb,0,Bar)-min)/point;
         low  = (Lo(Symb,0,Bar)-min)/point;
         if (UseMovingAverages)
          {
            FastMA=(iMA(Symb,0,FastMA_Period,0,MA,Ap_Price,Bar)-min)/point;
            if (FastMA<0 || FastMA>100)
             {
              FastMA=EMPTY_VALUE;
             } 
          
            SlowMA=(iMA(Symb,0,SlowMA_Period,0,MA,Ap_Price,Bar)-min)/point;
            if (SlowMA<0 || SlowMA>100)
             {
              SlowMA=EMPTY_VALUE;
             }
          }
          else
          {
           FastMA=EMPTY_VALUE;
           SlowMA=EMPTY_VALUE;
          } 
          
         if (ChartListPosition==0)
          {
           DrawHisto(open,high,low,close,FastMA,SlowMA,Bar+2);
          }
          else
          {
           DrawHisto(open,high,low,close,FastMA,SlowMA,Bar+ChartListPosition*Frame+2); 
          }
        } 
        else
        { 
          high = (Hi(Symb,0,Bar)-min)/point;
          low  = (Lo(Symb,0,Bar)-min)/point;
          haopen=(iCustom(Symb,0,"Heiken Ashi",2,Bar)-min)/point;
          haclose=(iCustom(Symb,0,"Heiken Ashi",3,Bar)-min)/point;
          hahigh=MathMax(high, MathMax(haopen, haclose));
          halow=MathMin(low, MathMin(haopen, haclose));
      
          if (!UseMovingAverages)
           {
            FastMA=EMPTY_VALUE;
            SlowMA=EMPTY_VALUE;
           }
           else
           {
            FastMA=(iMAOnArray(HAClose,0,FastMA_Period,0,MA,Bar-1)-min)/point;
            if (FastMA<0 || FastMA>100)
             {
              FastMA=EMPTY_VALUE;
             } 
             
            SlowMA=(iMAOnArray(HAClose,0,SlowMA_Period,0,MA,Bar-1)-min)/point;
            if (SlowMA<0 || SlowMA>100)
             {
              SlowMA=EMPTY_VALUE;
             } 
           } 
          
          if (ChartListPosition==0)
          {
           DrawHisto(haopen,hahigh,halow,haclose,FastMA,SlowMA,Bar+2);
          }
          else
          {
           DrawHisto(haopen,hahigh,halow,haclose,FastMA,SlowMA,Bar+ChartListPosition*Frame+2); 
          }
        } 
                 
   }  
//+------------------------------------------------------------------+
//|Reception of values of time for cell borders                      |
//+------------------------------------------------------------------+

void CellThresolds(int ChartListPosition)
   {
    FrameThresolds[ChartListPosition+1][1]=iTime(NULL,0,(ChartListPosition+1)*Frame-2);
    FrameThresolds[ChartListPosition+1][2]=iTime(NULL,0,(ChartListPosition+1)*Frame-2-(Frame-4));
   }    
//+------------------------------------------------------------------+
//| Deleting all charts                                              |
//+------------------------------------------------------------------+
   
void CleanHisto()
   {
    if (Bars!=0)
    {
    for(int i=0;i<=Bars-1;i++)
      {
       CleanBuffers(i);
       continue;
      }
    }  
   }
   
//+------------------------------------------------------------------+
//|draw separate lines                                               |
//+------------------------------------------------------------------+
   
void DrawSeparateLines(int ChartListPosition)
   { 
    int value;
       value=ChartListPosition*Frame;
       ExtMapBuffer5[value]=106;
       value+=Frame;
       ExtMapBuffer5[value]=106;
   }  
       
//+------------------------------------------------------------------+
//|Calculate indicator values                                        |
//+------------------------------------------------------------------+

void DrawHisto(double O,double H,double L,double C,double ma,double ma1,int Bar)
   {
           
            if (O > C) 
             {
              ExtMapBuffer1[Bar]=O;
              ExtMapBuffer2[Bar]=EMPTY_VALUE; 
              ExtMapBuffer3[Bar]=C;
              ExtMapBuffer4[Bar]=H;
              ExtMapBuffer5[Bar]=EMPTY_VALUE;
              
             }
          
            if (O < C) 
             {
              ExtMapBuffer1[Bar]=EMPTY_VALUE;
              ExtMapBuffer2[Bar]=C; 
              ExtMapBuffer3[Bar]=O;
              ExtMapBuffer4[Bar]=EMPTY_VALUE;
              ExtMapBuffer5[Bar]=H;
              
             
             } 
          
            if (O == C) 
             {
              ExtMapBuffer1[Bar]=O;
              ExtMapBuffer2[Bar]=EMPTY_VALUE; 
              ExtMapBuffer3[Bar]=O; 
              ExtMapBuffer4[Bar]=EMPTY_VALUE;
              ExtMapBuffer5[Bar]=H;
              
           
             }   
             ExtMapBuffer6[Bar]=L;
             FastMABuffer[Bar]=ma;
             SlowMABuffer[Bar]=ma1; 
   } 

   
void DeleteAllObjects(int Type)
   {
    if (idWnd!=-1) ObjectsDeleteAll(idWnd,Type);
   } 
   
//+------------------------------------------------------------------+
//|Sorting                                                           |
//+------------------------------------------------------------------+
   
void Sorting()
   {
    string Names[];
    int i,index; 
    ArrayResize(Names,Win_Charts);
    
    BubbleSort2(Vol,2,MODE_DESCEND);
    
    for(i=0;i<=Win_Charts-1;i++)
      {
       index=Vol[i+1,1];
       Names[i]=ChartNames[index];
       continue;
      }
      
    for(i=0;i<=Win_Charts-1;i++)
      {
       ChartNames[i]=Names[i];
       RefreshRate(i);
       UpgradeCharts(i);
       continue;
      } 
      
   }
      


//+------------------------------------------------------------------+
//|New Day bar                                                       |
//+------------------------------------------------------------------+

bool isNewDayBar()                                
  {                                            
   string  Symb;                                 
   bool result=true;   
   static datetime DayBar=0;    
   datetime NewBar=iTime(NULL,PERIOD_D1,0); 
                                         
   if(DayBar!=NewBar)                                            
     {
      for (int i=0; i<=Win_Charts-1;i++)
       {
        Symb=ChartNames[i];
        
        if (Symb==Symbol() || iTime(Symb,PERIOD_D1,0)==NewBar)
         {
          if (DayBarTime[i]!=NewBar) DayBarTime[i]=NewBar;
          continue;
         } 
         else
         {
          result=false; 
          break;
         }
       }
     }  
     else result=false; 
     
      if (result) 
       {
        DayBar=NewBar;                                            
       } 
                                   
  
    return(result); 
  }
     
//+-------------------------------------------------------------------+
//|it's new bar?                                                      |
//+-------------------------------------------------------------------+
   
bool  isNewBar(int ChartsListPosition)   
  {
     bool res=false; 
     RefreshRates();   
     string  Symb=ChartNames[ChartsListPosition];
     datetime BT=iTime(Symb,0,0);
     
   if ( ZeroBarTime[ChartsListPosition] !=BT || ZeroBarTime[ChartsListPosition] ==0 )
        {
          ZeroBarTime[ChartsListPosition] = BT;
          res=true;
        } 
    return(res);
  }
   
bool isNewic(int ChartsListPosition) 
 { 
   bool res=false;  
   RefreshRates();
   string Symb=ChartNames[ChartsListPosition];
   datetime TT = MarketInfo(Symb,MODE_TIME);
    
   if ( icTime[ChartsListPosition] != TT )  
     {
       icTime[ChartsListPosition] = TT ;
       res=true;
     } 
   return(res);  
 }  

void Symbolic()  
   {
    string name,Symb;
    for(int i=0; i<=Win_Charts-1; i++)      
      {  
       if (Hystory[i]==0)  
        {
         UpgradeCharts(i);
         Hystory[i]=RefreshRate(i);
        }
        else
        {
         MonitoringOpenPositions(i);
          if (isNewic(i))                     
             { 
              if (isNewBar(i))
               {
                Symb=ChartNames[i];
                LoadChartsValues();
               }   
               else
               {
                DrawZeroBar(i);
               }                                      
             } 
         } 
        continue; 
      }  
   }
//+------------------------------------------------------------------+
//|(need optimize)                                                   |
//+------------------------------------------------------------------+
double GetVol( int ChartListPosition)  
   {
        string Symb=ChartNames[ChartListPosition];
        int CurrentTF=Period();
        if ( CurrentTF<=PERIOD_D1) CurrentTF=PERIOD_D1;
        double volatility[10];
        double yesterday,Max,Min;
        int dig=MarketInfo(Symb,MODE_DIGITS);
        int Pips=MathPow(10,dig);
        
        for (int i=0; i<=9;i++)
         {
          Max=Hi(Symb,CurrentTF,i);
          Min=Lo(Symb,CurrentTF,i);
          volatility[i]=(Max-Min)*Pips;
         }
        
       return(iMAOnArray(volatility,0,10,0,MODE_SMA,0));
   }

   
 
 
//+------------------------------------------------------------------+
//| Monitoring total orders                                          |
//+------------------------------------------------------------------+
   
void MonitoringOpenPositions(int ChartsListPosition)
   {
    int SellCount=0,BuyCount=0;
    double Profit=0;
    string Symb=ChartNames[ChartsListPosition],Result;
    
  if(MonitoringPositions)
   { 
    if (ExistPositions_Orders(Symb,OP_SELL)==-1 && ExistPositions_Orders(Symb,OP_BUY)==-1 ) 
     {
        clNames[ChartsListPosition]=BullCandleColor;
        Result=" ";
     }     
     else
     {
          if (ExistPositions_Orders(Symb,OP_SELL)==OP_SELL) 
           {
                   SellCount=NumberOfOrders(ChartsListPosition,OP_SELL);
                   Profit=Profit(Symb); 
                   if (SellCount>1)
                    {
                      Result   =StringConcatenate(" [ Sell (",SellCount,"): ",Profit," ]");
                    }  
                    else
                    {
                      Result   =StringConcatenate(" [ Sell: ",Profit," ]");
                    } 
                   clNames[ChartsListPosition]=ColorChartName(ChartsListPosition,Profit,SellCount);
           }
    
          if (ExistPositions_Orders(Symb,OP_BUY)==OP_BUY) 
           { 
                   BuyCount =NumberOfOrders(ChartsListPosition,OP_BUY);
                   Profit=Profit(Symb);           
                   if (BuyCount>1)
                    {
                      Result   =StringConcatenate(" [ Buy (",BuyCount,"): ",Profit," ]");
                    }  
                    else
                    {
                      Result   =StringConcatenate(" [ Buy: ",Profit," ]");
                    }
                   clNames[ChartsListPosition]=ColorChartName(ChartsListPosition,Profit,BuyCount);
           }
     }    
         
           if (ExistPositions_Orders(Symb,OP_BUYSTOP)==OP_BUYSTOP) 
            { 
             NumberOfOrders(ChartsListPosition,OP_BUYSTOP);
            }
    
           if (ExistPositions_Orders(Symb,OP_BUYLIMIT)==OP_BUYLIMIT) 
            { 
             NumberOfOrders(ChartsListPosition,OP_BUYLIMIT);
            }
     
           if (ExistPositions_Orders(Symb,OP_SELLSTOP)==OP_SELLSTOP) 
            { 
             NumberOfOrders(ChartsListPosition,OP_SELLSTOP);
            }
    
           if (ExistPositions_Orders(Symb,OP_SELLLIMIT)==OP_SELLLIMIT) 
            { 
             NumberOfOrders(ChartsListPosition,OP_SELLLIMIT);
            }  
         
     }
     
        ChartName(ChartsListPosition,clNames[ChartsListPosition],Result);
        if (ViewOHLC) OHLC(ChartsListPosition); 
        DeleteOldTrendLines(ChartsListPosition);
   }
   
int CalcMode()
   {
    if (ProfitCalcMode!=0 && ProfitCalcMode!=1)
     {
      return(0);
     }
     else
     {
      return(ProfitCalcMode);
     }   
    } 
    
double Profit(string Symb)
   {
     if (CalcMode()==0)
                    {
                     return(GetProfitOpenPosInPoint(Symb, -1,-1));
                    }
                    else
                    { 
                     return(GetProfitOpenPosInCurrency(Symb, -1,-1));
                    } 
   }    
   
//+------------------------------------------------------------------+
//|Drawing color labels                                              |
//+------------------------------------------------------------------+
                
color ColorChartName(int ChartsListPosition,double Profit,int OrdersCount)    
   {
    string Symb=ChartNames[ChartsListPosition];
    double StopLevel;
    double point    =MarketInfo(Symb,MODE_POINT);
    double bid      =MarketInfo(Symb,MODE_BID);
    double ask      =MarketInfo(Symb,MODE_ASK);
    int    dig      =MarketInfo(Symb,MODE_DIGITS);
    color  test     =Win_color;
    int    pips     =MathPow(10,dig);
   
    StopLevel=100*point*pips;
    
    for(int j=1;j<=OrdersCount;j++)  
      {
       
         switch(TotalOrders[ChartsListPosition+1][j][6])
          {
           case OP_SELL: 
               if (TotalOrders[ChartsListPosition+1][j][2]!=0 && 
                   ask>=(TotalOrders[ChartsListPosition+1][j][2]-NormalizeDouble(StopLevel*point,dig)))  
                   {
                    test=StopLossColor;
                   } 
                   else
                   {
                   if (TotalOrders[ChartsListPosition+1][j][3]!=0 && 
                       ask<=(TotalOrders[ChartsListPosition+1][j][3]+NormalizeDouble(StopLevel*point,dig)))
                      {
                       test=TakeProfitColor;
                      }
                   }
             break;       
             
           case OP_BUY:     
                if (TotalOrders[ChartsListPosition+1][j][2]!=0 && 
                    bid<=(TotalOrders[ChartsListPosition+1][j][2]+NormalizeDouble(StopLevel*point,dig))) 
                   {
                    test=StopLossColor;
                   } 
                   else 
                   {
                     if (TotalOrders[ChartsListPosition+1][j][3]!=0 && 
                         bid>=(TotalOrders[ChartsListPosition+1][j][3]-NormalizeDouble(StopLevel*point,dig)))
                      {
                       test=TakeProfitColor;
                      }
                   }
            break;            
        }
      }   
        
        if (test==Win_color)
          {
           if (Profit>0)
            {
             test=ProfitColor; 
            }
            else 
            {
             if (Profit==0)
              {
               test=TextColor; 
              }
              else
              {
               test=LossColor; 
              }
            } 
          } 
        return(test);
                          
    }


//+----------------------------------------------------------------------------+
//|  Version   : 28.06.2009                                                    |
//|  Desc :      Returns quantity of open positions                            |
//|              Set orders lines                                              |
//+----------------------------------------------------------------------------+

int NumberOfOrders(int ChartListPosition, int op=-1)
 {
  int i, k=OrdersTotal(), ko=0, ot,idWnd,f,tp,sl;
  string Symb=ChartNames[ChartListPosition],objName,Type;
  int dig=MarketInfo(Symb,MODE_DIGITS);
  double orderprice=0,chartmin=0,chartpoint=0; 
  datetime pos,pos1;
  for (i=1; i<=30; i++)
   {
    TotalOrders[ChartListPosition+1][i][1]=0;
    TotalOrders[ChartListPosition+1][i][2]=0;
    TotalOrders[ChartListPosition+1][i][3]=0;
    TotalOrders[ChartListPosition+1][i][4]=0;
    TotalOrders[ChartListPosition+1][i][5]=0;
    TotalOrders[ChartListPosition+1][i][6]=0;
    TotalOrders[ChartListPosition+1][i][7]=0;
   }
   TotalOrders[ChartListPosition+1][0][0]=ko;
   idWnd=WindowFind(Win_Name);
   f=Frame-1;
   pos=FrameThresolds[ChartListPosition+1][1];
   pos1=FrameThresolds[ChartListPosition+1][2];
   chartpoint=ChartValues[ChartListPosition+1][1];
   chartmin=ChartValues[ChartListPosition+1][3]; 
   
  for (i=0; i<k; i++)
   {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
    {
      if ((OrderSymbol()==Symb) && (OrderType()==op))
        {
            ko++;
            TotalOrders[ChartListPosition+1][ko][1]=NormalizeDouble(OrderOpenPrice(),dig);
            TotalOrders[ChartListPosition+1][ko][2]=NormalizeDouble(OrderStopLoss(),dig);
            TotalOrders[ChartListPosition+1][ko][3]=NormalizeDouble(OrderTakeProfit(),dig);
            TotalOrders[ChartListPosition+1][ko][4]=OrderTicket();
            TotalOrders[ChartListPosition+1][ko][5]=OrderLots();
            TotalOrders[ChartListPosition+1][ko][6]=OrderType();
            TotalOrders[ChartListPosition+1][ko][7]=OrderMagicNumber();
            TotalOrders[ChartListPosition+1][0][0]=ko;
           
              switch(TotalOrders[ChartListPosition+1][ko][6])
              {
               case OP_BUY:
                        Type="Buy";
                break;
                
               case OP_BUYSTOP:
                        Type="Buy Stop";
                break;
                
               case OP_BUYLIMIT:
                        Type="Buy Limit";
                break; 
                 
               case OP_SELL:
                        Type="Sell";
                break;
                
               case OP_SELLSTOP:
                        Type="Sell Stop";
                break; 
                
              case OP_SELLLIMIT:
                        Type="Sell Limit";
                break;  
               }         
              objName=StringConcatenate("#",TotalOrders[ChartListPosition+1][ko][4]," ",Type);
              
//+------------------------------------------------------------------+
//|Lines for Sell,Buy....                                            |
//+------------------------------------------------------------------+
                     
              if (chartpoint!=0)
               {
                orderprice=NormalizeDouble((TotalOrders[ChartListPosition+1][ko][1]-chartmin)/chartpoint,dig);
                if (!FindObject(objName,idWnd) && (orderprice<=100 && orderprice>=0) )
                 {
                  if (TotalOrders[ChartListPosition+1][ko][6]==OP_SELL ||
                      TotalOrders[ChartListPosition+1][ko][6]==OP_BUY) 
                   {               
                    CreateTrendLine(objName,pos,pos1,orderprice,TextColor,idWnd);
                   }
                   else
                   {
                    CreateTrendLine(objName,pos,pos1,orderprice,BullCandleColor,idWnd);
                   } 
                 }
                 else
                 {
                  if (ObjectGet(objName,OBJPROP_PRICE1)!=orderprice || ObjectGet(objName,OBJPROP_PRICE2)!=orderprice)
                   {
                    if (orderprice<=100 && orderprice>=0)
                         {
                          ObjectSet(objName,OBJPROP_PRICE1,orderprice);
                          ObjectSet(objName,OBJPROP_PRICE2,orderprice);
                          ObjectSet(objName,OBJPROP_TIME1,pos);
                          ObjectSet(objName,OBJPROP_TIME2,pos1);
                         } 
                         else
                         {
                          ObjectDelete(objName);
                         } 
                   }
                 }  
               }  
               
//+------------------------------------------------------------------+
//|Line for TakeProfit                                               |
//+------------------------------------------------------------------+
               
               if (chartpoint!=0)
                {    
                  if (TotalOrders[ChartListPosition+1][ko][3]!=0)
                   {
                    tp=NormalizeDouble((TotalOrders[ChartListPosition+1][ko][3]-chartmin)/chartpoint,dig);
                    if (!FindObject("TP "+objName,idWnd))
                     {
                       if (tp<=100 && tp>=0)
                        {
                         CreateTrendLine("TP "+objName,pos,pos1,tp,TakeProfitColor,idWnd);
                        } 
                     }
                     else
                     {
                      if (ObjectGet("TP "+objName,OBJPROP_PRICE1)!=tp || ObjectGet("TP "+objName,OBJPROP_PRICE2)!=tp )
                       {
                        if (tp<=100 && tp>=0)
                         {
                          ObjectSet("TP "+objName,OBJPROP_PRICE1,tp);
                          ObjectSet("TP "+objName,OBJPROP_PRICE2,tp);
                          ObjectSet("TP "+objName,OBJPROP_TIME1,pos);
                          ObjectSet("TP "+objName,OBJPROP_TIME2,pos1);
                         } 
                         else
                         {
                          ObjectDelete("TP "+objName);
                         } 
                       }
                     }   
                   }
                   else
                   {
                    if (FindObject("TP "+objName,idWnd))
                     {
                      ObjectDelete("TP "+objName);
                     }
                   }
                 }  
                 
//+------------------------------------------------------------------+
//|Line for StopLoss                                                 |
//+------------------------------------------------------------------+

               if (chartpoint!=0)
                {    
                  if (TotalOrders[ChartListPosition+1][ko][2]!=0)
                   {
                    sl=NormalizeDouble((TotalOrders[ChartListPosition+1][ko][2]-chartmin)/chartpoint,dig);
                    if (!FindObject("SL "+objName,idWnd))
                     {
                      if (sl<=100 && sl>=0)
                       {
                        CreateTrendLine("SL "+objName,pos,pos1,sl,StopLossColor,idWnd);
                       } 
                     }
                     else
                     {
                      if (ObjectGet("SL "+objName,OBJPROP_PRICE1)!=sl || ObjectGet("SL "+objName,OBJPROP_PRICE2)!=sl)
                       {
                        if (sl<=100 && sl>=0)
                         {
                          ObjectSet("SL "+objName,OBJPROP_PRICE1,sl);
                          ObjectSet("SL "+objName,OBJPROP_PRICE2,sl);
                          ObjectSet("SL "+objName,OBJPROP_TIME1,pos);
                          ObjectSet("SL "+objName,OBJPROP_TIME2,pos1);
                         } 
                         else
                         {
                          ObjectDelete("SL "+objName);
                         }
                       }
                     }  
                   }
                   else
                   {
                     if (FindObject("SL "+objName,idWnd))
                      {
                       ObjectDelete("SL "+objName);
                      } 
                   } 
                 }  
             
          }
       }  
    }
    return(TotalOrders[ChartListPosition+1][0][0]);
 }  
 
//+------------------------------------------------------------------+
//|Clear lines,if order was close                                    |
//+------------------------------------------------------------------+

void DeleteOldTrendLines(int ChartListPosition)
   {
    
      int i, k=OrdersHistoryTotal(), ko=0,idWnd,ticket;
      string Symb=ChartNames[ChartListPosition],objName,Type;
    
      idWnd=WindowFind(Win_Name);
     
     for (i=0; i<k; i++) 
     {
      if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) 
       {
        if (OrderSymbol()==Symb)
         {
          
            switch(OrderType())
             {
              case OP_BUY:
                     Type="Buy";
               break;
               
              case OP_BUYSTOP:
                     Type="Buy Stop";
               break; 
               
              case OP_BUYLIMIT:
                     Type="Buy Limit";
               break;   
               
              case OP_SELL:
                     Type="Sell";
               break;
              
              case OP_SELLSTOP:
                     Type="Sell Stop";
               break;
               
              case OP_SELLLIMIT:
                     Type="Sell Limit";
               break;     
             }           
             ticket=OrderTicket();
             objName=StringConcatenate("#",ticket," ",Type);
             if (FindObject(objName,idWnd))
              {
               ObjectDelete(objName);
              }
             objName=StringConcatenate("TP ","#",ticket," ",Type); 
             if (FindObject(objName,idWnd))
              {
               ObjectDelete(objName);
              }
             objName=StringConcatenate("SL ","#",ticket," ",Type); 
             if (FindObject(objName,idWnd))
              {
               ObjectDelete(objName);
              } 
          }
        }
      }
    
  }
////////////////////////////////////////////////////////////////////////////////////

   
double Op(string Symb,int period,int Bar)
   {
    return(iOpen(Symb,period,Bar));
   }     
 
double Cl(string Symb,int period,int Bar)
   {
    return(iClose(Symb,period,Bar));
   } 
   
double Hi(string Symb,int period,int Bar)
   {
    return(iHigh(Symb,period,Bar));
   }   
   
double Lo(string Symb,int period,int Bar) 
   {
    return(iLow(Symb,period,Bar));
   }
   
//+------------------------------------------------------------------+
//|Return string name of TimeFrame                                   |
//+------------------------------------------------------------------+

string TF()
   {
    string   Periods[9][2]={  "1", ": M1",
                              "5", ": M5",
                             "15", ": M15",
                             "30", ": M30",
                             "60", ": H1",
                             "240", ": H4",
                             "1440", ": Daily",
                             "10080", ": Weekly",
                             "43200", ": Monthly"}; 
     for(int i=0; i<9; i++)
       {
        if(Periods[i][0]==DoubleToStr(Period(),0)) return(Periods[i][1]);
       }
   } 


//+------------------------------------------------------------------+
//|Create TrendLine                                                  |
//+------------------------------------------------------------------+

void CreateTrendLine(string obj,datetime position,datetime position1,double price,color cl,int idWnd)
   {
    ObjectCreate(obj,OBJ_TREND,idWnd,position,price,position1,price);
    ObjectSet(obj,OBJPROP_COLOR,cl);
    ObjectSet(obj,OBJPROP_STYLE,STYLE_DOT);
    ObjectSet(obj,OBJPROP_RAY,false);
   }        
//+------------------------------------------------------------------+
//| Create Text                                                      |
//+------------------------------------------------------------------+
     
void CreateTextObject(string Win_Name,string obj, double x, double y,string Text,color cl,string FontName,int FontSize) 
  {
   int ChartWindow;
   ChartWindow=WindowFind(Win_Name);
   ObjectCreate(obj, OBJ_TEXT, ChartWindow, x, y);
   ObjectSetText(obj,Text,FontSize, FontName, cl);
  }
//+------------------------------------------------------------------+
//|Create Label                                                      |
//+------------------------------------------------------------------+

void CreateLabelObject(string obj, int Corner, int x, int y,string Text,color cl) 
  {
   ObjectCreate(obj, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(obj,Text, 7, "Tahoma", cl);
   ObjectSet(obj, OBJPROP_CORNER   , Corner);
   ObjectSet(obj, OBJPROP_XDISTANCE, x      );
   ObjectSet(obj, OBJPROP_YDISTANCE, y      );
  } 
  
//+------------------------------------------------------------------+
//|Find object                                                       |
//+------------------------------------------------------------------+
    
bool FindObject(string Object, int idWnd)
   {
     if (ObjectFind(Object)==idWnd) return(true);
      else return(false);
   }  

//+----------------------------------------------------------------------------+
//|  Author   : Kim I. aka KimIV,  http://www.kimiv.ru                         |
//+----------------------------------------------------------------------------+
//|  Version  : 04.11.2008                                                     |
//|  Desc     : BubleSort for matrix                                           |
//+----------------------------------------------------------------------------+

void BubbleSort2(double& a[][], int r=0, int m=MODE_ASCEND)
 {
  double t;
  int    e, i, j;
  int    k=ArrayRange(a, 1);      // Columns
  int    n=ArrayRange(a, 0);      // Lines

  if (r<0) r=0;
  if (r>k) r=k;

  for (i=n-1; i>0; i--)
   {
    for (j=1; j<i; j++) 
    {
      if (m==MODE_ASCEND)
       {
        // 
        if (a[j][r]>a[j+1][r])
         {
          for (e=0; e<k; e++) 
          {
            t=a[j][e];
            a[j][e]=a[j+1][e];
            a[j+1][e]=t;
          }
        }
      } 
      else
       {
        // 
        if (a[j][r]<a[j+1][r]) {
          for (e=0; e<k; e++) {
            t=a[j][e];
            a[j][e]=a[j+1][e];
            a[j+1][e]=t;
          }
        }
      }
    }
  }
}    

   
//+------------------------------------------------------------------+
//|Returns percent of change of the price of the tool from the last day  |
//|------------------------------------------------------------------+
//| PercentCalcMode=0  in percent                                    |
//| PercentCalcMode=1  in pips                                       |
//+------------------------------------------------------------------+
double GetPercent(string Symb="",int PercentCalcMode=0)
   {    
        int CurrentTF=Period();
        if ( CurrentTF<=PERIOD_D1) CurrentTF=PERIOD_D1;
        double yesterday=iClose(Symb , CurrentTF,  1);
        int dig=MarketInfo(Symb,MODE_DIGITS);
        int Pips=MathPow(10,dig);
        double today=0;
        int    metod;
        
        if (PercentCalcMode!=0 && PercentCalcMode!=1)
         {
          metod=0;
         }
         else 
          metod=PercentCalcMode;
          
        if (yesterday!= 0 ) 
         {
          switch(metod)
           {
            case 0: today=(iClose(Symb,CurrentTF  ,0) * 100 ) / yesterday - 100; break;
            case 1: today=(iClose(Symb,CurrentTF  ,0)-yesterday)*Pips;break;
           } 
         }  
      return (today);
   }


int ExistPositions_Orders(string Symb,int op=-1) 
{
  int i, k=OrdersTotal();

  for (i=0; i<k; i++) 
  {
    if (OrderSelect(i, SELECT_BY_POS,MODE_TRADES))
    {
      if (OrderSymbol()==Symb && (OrderType()==op || op<0) ) 
      {
        
         return(OrderType());          
       
      }
    }
  }
  return(-1);
}


double GetProfitOpenPosInCurrency(string sy="", int op=-1, int mn=-1)
 {
  double p=0;
  int    i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) 
  {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
    {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op))
       {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL)
         {
          if (mn<0 || OrderMagicNumber()==mn) 
          {
            p+=OrderProfit()+OrderCommission()+OrderSwap();
          }
        }
      }
    }
  }
  return(p);
}


int GetProfitOpenPosInPoint(string sy="", int op=-1, int mn=-1) {
  double p;
  int    i, k=OrdersTotal(), pr=0;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (mn<0 || OrderMagicNumber()==mn) {
          p=MarketInfo(OrderSymbol(), MODE_POINT);
          if (p==0) if (StringFind(OrderSymbol(), "JPY")<0) p=0.0001; else p=0.01;
          if (OrderType()==OP_BUY) {
            pr+=(MarketInfo(OrderSymbol(), MODE_BID)-OrderOpenPrice())/p;
          }
          if (OrderType()==OP_SELL) {
            pr+=(OrderOpenPrice()-MarketInfo(OrderSymbol(), MODE_ASK))/p;
          }
        }
      }
    }
  }
  return(pr);
}
    